> This page is for Developers.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://zuora.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://zuora.ferndocs.com/_mcp/server.

# List schedules for a commitment

GET https://rest.test.zuora.com/commitments/{commitmentKey}/schedules

Retrieves all the schedules for a specific commitment.


Reference: https://zuora.ferndocs.com/developers/api-reference/zuora-api/orders-and-subscriptions/commitments/list-commitment-schedules

## Authentication

- `Authorization` header (bearer token, required) — Use `Bearer {{token}}` in the `Authorization` header for authentication.

## Servers

- `https://rest.test.zuora.com` (US Developer & Central Sandbox (incl. Test Drive), default)
- `https://rest.sandbox.na.zuora.com` (US API Sandbox Cloud 1)
- `https://rest.apisandbox.zuora.com` (US API Sandbox Cloud 2)
- `https://rest.na.zuora.com` (US Production Cloud 1)
- `https://rest.zuora.com` (US Production Cloud 2)
- `https://rest.test.eu.zuora.com` (EU Developer & Central Sandbox)
- `https://rest.sandbox.eu.zuora.com` (EU API Sandbox)
- `https://rest.eu.zuora.com` (EU Production)
- `https://rest.test.ap.zuora.com` (APAC Developer & Central Sandbox)
- `https://rest.ap.zuora.com` (APAC Production)

## Request

### Path parameters

- `commitmentKey` (string, required) — The unique identifier (ID or number) of the commitment.

### Query parameters

- `page` (integer, optional, default: 1) — Page number for pagination.
- `pageSize` (integer, optional, default: 20) — Page size for pagination.

### Headers

- `Accept-Encoding` (string, optional) — Include the `Accept-Encoding: gzip` header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a `Content-Encoding` header with the compression algorithm so that your client can decompress it.
- `Content-Encoding` (string, optional) — Include the `Content-Encoding: gzip` header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
- `Zuora-Entity-Ids` (string, optional) — An entity ID. If you have [Zuora Multi-entity](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/Multi-entity) enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
- `Zuora-Org-Ids` (string, optional) — Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs.
- `Zuora-Track-Id` (string, optional) — A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (`:`), semicolon (`;`), double quote (`"`), and quote (`'`).
- `Zuora-Version` (string, optional) — The minor API version. For a list of available minor versions, see [API upgrades](https://developer.zuora.com/v1-api-reference/api-upgrades/).

## Response

### 200

OK

- `schedules` (list of ListCommitmentScheduleOutput, optional) — A list of commitment schedule objects.
- `total` (integer, optional) — Total number of schedules available for the given commitment.
- `page` (integer, optional) — The current page number.
- `pageSize` (integer, optional) — The number of results returned per page.

## Errors

### 500 Internal Server Error

Internal Server Error

- `reasons` (list of ErrorResponseReasonsItems, optional)

### 400 Client Request Error

Request Errors

- `processId` (string, optional) — The ID of the process that handles the operation.
- `reasons` (list of CommonResponseReasonsItems, optional) — The container of the error code and message. This field is available only if the `success` field is `false`.
- `requestId` (string, optional) — Unique identifier of the request.
- `success` (boolean, optional) — Indicates whether the call succeeded.

## Types

### ListCommitmentScheduleOutput

- `id` (string, optional) — ID of the commitment schedule.
- `commitmentId` (string, optional) — ID of the commitment.
- `commitmentNumber` (string, optional) — The number of the commitment.
- `version` (integer, optional) — Version of the commitment schedule.
- `startDate` (date, optional) — Ths start date of the commitment schedule.
- `endDate` (date, optional) — The end date of the commitment schedule.
- `prepaymentDefinition` (PrepaymentDefinition, optional) — The prepayment definition for the commitment schedule.
- `totalAmount` (double, optional) — The total amount of the commitment schedule.
- `amount` (double, optional) — The non-prorated actual amount of the commitment schedule.
- `amountBase` (enum, optional, default: CommitmentPeriod) — The level for which the committed amount applies to.
  - Allowed values: `CommitmentPeriod`
- `periodType` (enum, optional, default: Month) — The frequency type of the period of the commitment schedule.
  - Allowed values: `Month`, `Quarter`, `SemiAnnual`, `Year`, `SpecificMonths`, `SinglePeriod`
- `specificPeriodLength` (integer, optional) — The specific length of the period, required if `periodType` is `SpecificMonths`.
- `status` (enum, optional) — Status of the commitment schedule.
  - Allowed values: `Active`, `Cancelled`, `Evaluated`, `CancelledPendingEvaluation`

### ErrorResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

### CommonResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

### PrepaymentDefinition

The prepayment definition for the commitment schedule.

- `prepaymentFrequency` (enum, optional) — The prepayment frequency for the prepayment definition. If the value is `Specific_Months`, `Specific_Weeks`, or `Specific_Days`, use the `specificFrequency` field to specify the duration.
  - Allowed values: `Month`, `Quarter`, `Semi_Annual`, `Annual`, `Eighteen_Months`, `Two_Years`, `Three_Years`, `Five_Years`, `Specific_Months`, `Week`, `Specific_Weeks`, `Specific_Days`
- `specificFrequency` (integer, optional) — The specific frequency length. This field is required when `prepaymentFrequency` is `Specific_Months`, `Specific_Weeks`, or `Specific_Days`.
- `customFields` (map from string to any, optional) — Container for custom fields of a prepayment definition object.

## Examples

**Response**

```json
{
  "schedules": [
    {
      "id": "0df89cf12e650006ac13624398764f1b",
      "commitmentId": "8ad08ca797ef6ca50197f3cce6267991",
      "commitmentNumber": "TW-0001",
      "version": 1,
      "startDate": "2020-01-01",
      "endDate": "2020-12-31",
      "prepaymentDefinition": {
        "prepaymentFrequency": "Specific_Months",
        "specificFrequency": 4,
        "customFields": {}
      },
      "totalAmount": 300,
      "amount": 200,
      "amountBase": "CommitmentPeriod",
      "periodType": "SpecificMonths",
      "specificPeriodLength": 4,
      "status": "Active"
    }
  ],
  "total": 1,
  "page": 1,
  "pageSize": 20
}
```

**SDK Code**

```python Commitments_listCommitmentSchedules_example
import requests

url = "https://rest.test.zuora.com/commitments/commitmentKey/schedules"

headers = {"Authorization": "Bearer <token>"}

response = requests.get(url, headers=headers)

print(response.json())
```

```javascript Commitments_listCommitmentSchedules_example
const url = 'https://rest.test.zuora.com/commitments/commitmentKey/schedules';
const options = {method: 'GET', headers: {Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Commitments_listCommitmentSchedules_example
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/commitments/commitmentKey/schedules"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Commitments_listCommitmentSchedules_example
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/commitments/commitmentKey/schedules")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java Commitments_listCommitmentSchedules_example
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://rest.test.zuora.com/commitments/commitmentKey/schedules")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php Commitments_listCommitmentSchedules_example
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://rest.test.zuora.com/commitments/commitmentKey/schedules', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp Commitments_listCommitmentSchedules_example
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/commitments/commitmentKey/schedules");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift Commitments_listCommitmentSchedules_example
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/commitments/commitmentKey/schedules")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```